<script lang="ts">
import Vue from 'vue';
import { TheSourceService } from '~/services';
import {
  getAvailableLanguagesFromTags,
  getUrlFromContentfulImage,
} from '~/common/util';
import { CtfEntry, CtfPage, CtfSeo } from '~/models';
import { AvailableLanguagesMixin } from '~/mixins';
import TheSourceFeatured from '~/components/the-source/featured.vue';
import TheSourceLandingCategory from '~/components/the-source/landing-category.vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: { TheSourceLandingCategory, TheSourceFeatured },
  mixins: [AvailableLanguagesMixin],
  layout: 'the-source',
  async middleware(context) {
    if (process.client) {
      return;
    }

    const page: CtfEntry<CtfPage> =
      await context.$theSourceService.getLandingContent();

    context.$pageData = page;
    context.$availableLanguages = getAvailableLanguagesFromTags(
      page.metadata.tags,
    );
  },
  async asyncData({
    $theSourceService,
    $pageData,
    $availableLanguages,
  }: {
    $theSourceService: TheSourceService;
  }) {
    try {
      const [featured, mostRecentArticles, categories] = await Promise.all([
        $theSourceService.getFeaturedArticle(),
        $theSourceService.getMostRecentArticles(),
        $theSourceService.getCategories(),
      ]);

      const page = $pageData;
      const seoMetadata: CtfEntry<CtfSeo> =
        page.fields?.seoMetadata && page.fields?.seoMetadata[0];

      return {
        page,
        featured,
        mostRecentArticles,
        categories,
        metadata: {
          title: seoMetadata?.fields?.title || seoMetadata?.fields?.ogTitle,
          description:
            seoMetadata?.fields?.description ||
            seoMetadata?.fields?.ogDescription,
          image_title: getUrlFromContentfulImage(
            seoMetadata?.fields?.ogImage?.fields?.image,
          ),
        },
        availableLanguages: $availableLanguages,
      };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      this.metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
      this.availableLanguages,
    );
  },
});
</script>

<template>
  <section>
    <TheSourceFeatured
      v-if="featured"
      :recent="mostRecentArticles"
      :article="featured?.fields"
    />
    <TheSourceLandingCategory
      v-for="(category, index) in categories"
      :key="category.sys.id"
      :category="category"
      :parent-index="index"
    />
  </section>
</template>

<style scoped lang="scss"></style>
